# -*- coding: utf-8 -*-
"""ITS307 - Assignment 2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/184bYXZoZNIGTSPr89X4ggpQNzUUQm1my

# ITS307 Data Analytics : Spring Semester 2022
# Assignment 2
# Supervised Learning - Linear Regression

# Table of Contents 
<ol start="0">
<li> Learning Objectives </li>
<li> Importing Libraries </li>
<li> Loading and Cleaning with Pandas</li>
<li> EDA  </li>
<li> Feature Engineering  </li>
<li> Training Model</li>
<li> Predicting</li>
<li> Evaluating Model</li>

</ol>

# Learning Objectives

Second-hand car have huge market base. Many consider to buy a Used Car intsead of buying of new one, as it's is feasible and a better investment.

The dataset shared contains some of the features that determines the second hand car's price in India. Some of the features of are:
- Name: The brand and model of the car
- Location: The location in which the car is being sold or is available for purchase.
- Year: Year or edition of the model
- Kilometers_Driven: The total kilometres driven in the car by the previous owner(s) in KM
- Fuel_Type: The type of fuel used by the car. (Petrol, Diesel, Electric, CNG, LPG)
- Transmission: The type of transmission used by the car. (Automatic / Manual)
- Owner_Type: Whether the owner is first owner or second owner and so on.
- Mileage: The standard mileage offered by the car company in kmpl or km/kg
- Engine: The displacement volume of the engine in CC.
- Power:
- Seat: Number of the seat of car
- New_Price: Price of the car when its new/first hand
- Price (Target) : Price of the used car

# 1. Loading Libraries
"""

import warnings
warnings.filterwarnings('ignore')

#importing the libraries
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns

from sklearn import datasets
import numpy as np
from sklearn.preprocessing import MinMaxScaler
from sklearn.linear_model import LinearRegression
from sklearn.metrics import mean_squared_error
from sklearn.metrics import mean_absolute_error



"""# 2. Loading and Cleaning with Pandas"""

train=pd.read_csv('/content/train-data.csv')
test=pd.read_csv('/content/test-data.csv')

train.head()

test.head()

# null values
print(train.isnull().sum())
print(test.isnull().sum())

print("Train size",train.shape)
print("Test size",test.shape)

train.drop(['New_Price'],axis = 1, inplace = True)
print("Train size",train.shape)
test.drop(['New_Price'],axis = 1, inplace = True)
print("Test size",test.shape)

train.info()

test_df.info()

train.isnull().sum()

test.isnull().sum()

train.dropna(inplace = True, axis = 0)
train.shape

test.dropna(inplace = True, axis = 0)
train.shape

# removing unnamed columns
train = train.loc[:, ~train.columns.str.contains('^Unnamed')]
test = test.loc[:, ~test.columns.str.contains('^Unnamed')]

train.head()

test.head()

train.dtypes

test.dtypes

# Finding unique values in Engine, Mileage and Power columns
print(train['Engine'].unique())
print(train['Mileage'].unique())
print(train['Power'].unique())
print("\n")
print(test['Engine'].unique())
print(test['Mileage'].unique())
print(test['Power'].unique())

# Removing the string from Engine, Mileage and Power columns
train["Engine"] = train["Engine"].str.replace('CC',' ')
train['Mileage'] = train['Mileage'].str.replace('km/kg', ' ')
train['Mileage'] = train['Mileage'].str.replace('kmpl', ' ')
train['Power'] = train['Power'].str.replace('bhp', ' ')
train.head(5)

test["Engine"] = test["Engine"].str.replace('CC',' ')
test['Mileage'] = test['Mileage'].str.replace('km/kg', ' ')
test['Mileage'] = test['Mileage'].str.replace('kmpl', ' ')
test['Power'] = test['Power'].str.replace('bhp', ' ')
test.head(5)

train.info()

test.info()

# Converting object to float of Engine, Mileage and Power columns
train["Engine"] = train["Engine"].astype(float)
train["Mileage"] = train["Mileage"].astype(float)
test["Engine"] = test["Engine"].astype(float)
test["Mileage"] = test["Mileage"].astype(float)

train['Power'] = train['Power'].str.replace('null','0')
test['Power'] = test['Power'].str.replace('null','0')

# Changing dtypes
train["Power"] = train["Power"].astype(float)
test["Power"] = test["Power"].astype(float)

train_df.info()

test.info()

# Replaceing 0 values as nan
train['Power'] = train['Power'].replace(0, np.nan)
train.isnull().sum()

# Replacing 0 values as nan
test['Power'] = test['Power'].replace(0, np.nan)
test.isnull().sum()

# Checking and dropping null values
train.dropna(inplace = True)
print(train.shape)
train.isnull().sum()

# Checking and dropping null values
test.dropna(inplace = True)
print(test_df.shape)
test.isnull().sum()

"""# 4. EDA and Visualization"""

# Checking null values
sns.heatmap(train.isnull(), yticklabels = False, cmap = 'coolwarm')

sns.heatmap(test_df.isnull(), yticklabels = False, cmap = 'coolwarm')

# Listing categorical columns for checking data imbalance and plotting them
col_category = ['Fuel_Type','Transmission','Owner_Type','Year']

k=0
plt.figure(figsize=(25,30))
for col in col_category:    
    k=k+1
    plt.subplot(4, 3,k)    
    train[col].value_counts().plot(kind='bar');
    plt.title(col)

col_category1 = ['Fuel_Type','Transmission','Owner_Type','Year']

k=0
plt.figure(figsize=(25,30))
for col in col_category1:    
    k=k+1
    plt.subplot(4, 3,k)    
    test[col].value_counts().plot(kind='bar');
    plt.title(col)

# Finding correlation of columns with Price
corr = train.corr()['Price']
corr

train["Price"].hist()

train["Year"].hist()

# Scatter plot
train.plot(x = 'Engine', y = 'Price', kind = 'scatter')



"""# 4. Feature Engineering


"""

# Checking the distribution of categorial data(train_df)
print("Train CSV \n")
print(train.Fuel_Type.value_counts())
print(train.Transmission.value_counts())
print(train.Owner_Type.value_counts())
print(train.Seats.value_counts())
print("\n")
print("Test CSV \n")
print(test.Fuel_Type.value_counts())
print(test.Transmission.value_counts())
print(test.Owner_Type.value_counts())
print(test.Seats.value_counts())

# One hot encoding for Categorical data
train.replace({'Fuel_Type':{'Diesel': 0, 'Petrol': 1, 'CNG': 2, 'LPG':3}}, inplace = True)
train.replace({'Transmission':{'Automatic': 0, 'Manual': 1}}, inplace = True)
train.replace({'Owner_Type':{'First': 0, 'Second': 1, 'Third': 2, 'Fourth & Above':3}}, inplace = True)
train.head(5)

test.replace({'Fuel_Type':{'Diesel': 0, 'Petrol': 1, 'CNG': 2, 'LPG':3}}, inplace = True)
test.replace({'Transmission':{'Automatic': 0, 'Manual': 1}}, inplace = True)
test.replace({'Owner_Type':{'First': 0, 'Second': 1, 'Third': 2, 'Fourth & Above':3}}, inplace = True)
test.head(5)

# Creating columns for checking outliners
cols=['Engine', 'Mileage','Kilometers_Driven']

# Engine outlier
sns.boxplot(train[cols[0]]);

# Mileage outlier
sns.boxplot(train[cols[1]]);

# Kilometer_Driven outlier
sns.boxplot(train[cols[2]]);

#Quantile Range(IQR) method.
def find_outliers_limit(train,col):
    print(col)
    print('-'*50)
    #removing outliers
    Q1, Q3 = np.percentile(train[col], 25), np.percentile(train[col], 75)
    IQR = Q3 - Q1
    print('Percentiles: 25th=%.3f, 75th=%.3f, IQR=%.3f' % (Q1, Q3, IQR))
    # calculate the outlier cutoff
    # upperlimit = Q3 + (IQR * 1.5)cut_off
    # lowerlimit = Q1 - (IQR * 1.5)cut_off
    cut_off = IQR * 1.5
    lower, upper = Q1 - cut_off, Q3 + cut_off
    print('Lower:',lower,' Upper:',upper)
    return lower,upper
def remove_outlier(train,col,upper,lower):
  # identify outliers
  outliers = ["x for x in train_df[col] if x  upper"]
  print('Identified outliers: %d' % len(outliers))
  # remove outliers
  outliers_removed = [x for x in train[col] if x >= lower and x <= upper]
  print('Non-outlier observations: %d' % len(outliers_removed))
  final= np.where(train[col]>upper,upper,np.where(train[col]<lower,lower,train[col]))
  return final
outlier_cols=['Engine','Mileage','Kilometers_Driven']
for col in outlier_cols:
  lower,upper=find_outliers_limit(train,col)
  train[col] = remove_outlier(train,col,upper,lower)

# After removing outliers
plt.figure(figsize=(20,10))
train[outlier_cols].boxplot()

# Creating columns for checking outliners
cols1=['Engine', 'Mileage','Kilometers_Driven']

#Quantile Range(IQR) method.
def find_outliers_limit(test,col):
    print(col)
    print('-'*50)
    #removing outliers
    Q1, Q3 = np.percentile(test[col], 25), np.percentile(test[col], 75)
    IQR = Q3 - Q1
    print('Percentiles: 25th=%.3f, 75th=%.3f, IQR=%.3f' % (Q1, Q3, IQR))
    # calculate the outlier cutoff
    # upperlimit = Q3 + (IQR * 1.5)cut_off
    # lowerlimit = Q1 - (IQR * 1.5)cut_off
    cut_off = IQR * 1.5
    lower, upper = Q1 - cut_off, Q3 + cut_off
    print('Lower:',lower,' Upper:',upper)
    return lower,upper
def remove_outlier(test_df,col,upper,lower):
  # identify outliers
  outliers = ["x for x in train_df[col] if x  upper"]
  print('Identified outliers: %d' % len(outliers))
  # remove outliers
  outliers_removed = [x for x in test[col] if x >= lower and x <= upper]
  print('Non-outlier observations: %d' % len(outliers_removed))
  final= np.where(test[col]>upper,upper,np.where(test[col]<lower,lower,test[col]))
  return final
outlier_cols1=['Engine','Mileage','Kilometers_Driven']
for col in outlier_cols1:
  lower,upper=find_outliers_limit(test,col)
  test[col] = remove_outlier(test,col,upper,lower)

# After removing outliers
plt.figure(figsize=(20,10))
test[outlier_cols1].boxplot()

#Changing Categorical data into Quantitative data using Get_dummies function
train = pd.get_dummies(train,columns=['Location','Seats'])
train.head(5)

#Changing Categorical data into Quantitative data using Get_dummies function
test = pd.get_dummies(test,columns=['Location','Seats'])
test.head(5)

train.info()

test.info()

"""# 5. Training Model"""

# Combining test and train df
final_df = pd.concat([train, test], axis = 0)
print(final_df.shape)
final_df.head(5)

#Removing duplicates values
final_df = final_df.loc[:,~final_df.columns.duplicated()]
print(final_df.shape)
final_df.isnull().sum()

final_df.dropna(inplace = True)
print(final_df.shape)
final_df.isnull().sum()

# Selecting target columns as price
y = final_df['Price']
X = final_df.drop(['Price','Name'], axis = 1)

y.dtypes

y.head(2)

X.head(5)

#Splitting of the data into Training and Testing
from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size = 0.20, random_state = 10)

# Checking shape of all splitted data
print("X_train",X_train.shape,"X_test",X_test.shape,"y_train",y_train.shape,"y_test",y_test.shape)

X_train.head(2)

X_test.head(2)

y_train.max()

from sklearn.preprocessing import StandardScaler
from sklearn.metrics import accuracy_score, confusion_matrix, classification_report, plot_confusion_matrix

# Using standard scaler for features preprocessing
scaler = StandardScaler()
scale = scaler.fit(X_train)
X_train = scale.transform(X_train)
X_test = scale.transform(X_test)

# Creating the model using scikit learn 
regression_model = LinearRegression(fit_intercept=True)
regression_model.fit(X_train, y_train)

"""# 6. Prediction"""

# Make a prediction against the test set to score our model
y_pred = regression_model.predict(X_test)
y_pred



"""# 7. Evaluating your Model"""

from sklearn.metrics import r2_score 
y_train_pred = regression_model.predict(X_train)
y_test_pred = regression_model.predict(X_test)
print("Train set Accuracy :", r2_score(y_train,y_train_pred))
print("Test set Accuracy :", r2_score(y_test,y_test_pred))

# Errors
print('-----------Errors------------')
print('R-squared training data: ', regression_model.score(X_train, y_train))
print('R-squared test data: ', regression_model.score(X_test, y_test))
print('MSE: ', mean_squared_error(y_test, y_pred))
print('MAE: ', mean_absolute_error(y_test, y_pred))
print('RMSE: ', np.sqrt(mean_squared_error(y_test, y_pred)))

Result = pd.DataFrame({"Actual Price":y_test,"Predicted Price":y_test_pred})
Result.tail(10)

"""# SUBMISSION DATE: 2nd April 2022"""